<?php
/**
 * Copyright (C) 2004 Billy Biggs <vektor@dumbterm.net>.
 *
 * Permission is hereby granted, free of charge, to any person obtaining
 * a copy of this software and associated documentation files (the
 * "Software"), to deal in the Software without restriction, including
 * without limitation the rights to use, copy, modify, merge, publish,
 * distribute, sublicense, and/or sell copies of the Software, and to
 * permit persons to whom the Software is furnished to do so, subject to
 * the following conditions:
 *
 * The above copyright notice and this permission notice shall be
 * included in all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
 * IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
 * CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
 * TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
 * SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 */
?>

<html>
<head>
    <title>Album List</title>
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8">
    <meta http-equiv="Content-Style-Type" content="text/css">
    <link href="http://mp3/mp3.css" rel="stylesheet" type="text/css">
</head>
<body>

<?php $control = "/mp3/control/"; ?>

<div class="bpagemargined">

    <?php
    function compare_name( $val1, $val2 ) {
        $first = $val1->name;
        $second = $val2->name;

        if( !strcmp( substr( $val1->name, 0, 4 ), "The " ) ) {
            $first = substr( $val1->name, 4 );
        }
        if( !strcmp( substr( $val2->name, 0, 4 ), "The " ) ) {
            $second = substr( $val2->name, 4 );
        }

        if( !strcmp( substr( $val1->name, 0, 1 ), "~" ) ) {
            $first = substr( $val1->name, 1 );
        }
        if( !strcmp( substr( $val2->name, 0, 1 ), "~" ) ) {
            $second = substr( $val2->name, 1 );
        }

        return strcasecmp( $first, $second );
    }

    $albums = fopen( "$control" . "albums.txt", "r" );
    $albumcount = 0;
    $albumlist = array();

    while( $cur = fgets( $albums, 1024 ) ) {
        $curname = basename($cur);
        $albumlist[ $albumcount ]->path = $cur;
        $albumlist[ $albumcount ]->name = $curname;
        $albumcount++;
    }
    fclose( $albums );
    usort( $albumlist, "compare_name" );

    $playalbum = $_GET[ "play" ];
    $albumid = $_GET[ "albumid" ];
    if( !strcmp( $playalbum, "please" ) ) {
        $fp = fopen( "$control" . "disc", 'w' );
        fwrite( $fp, $albumlist[ $albumid ]->path );
        fclose( $fp );
        touch("$control" . "load");
        sleep( 1 );
    }
    ?>

    <h3 class="center"><a href="/control/"><?php
            readfile("$control" . "nowplaying-album");
        ?></a></h3>
    <h4 class="center"><a href="/control/"><?php
            readfile("$control" . "nowplaying-track");
        ?></a></h4>

    <h3>Album List</h3>
    <p><ol>
    <?php
        for( $i = 0; $i < sizeof( $albumlist ); $i++ ) {
             $name = $albumlist[ $i ]->name;
             $path = $albumlist[ $i ]->path;

             echo "    <li><a href=\"?play=please&albumid=$i\">$name</a>\n";
             if( $i % 10 == 9 ) {
                 echo "    <p></p>\n";
            }
        }
    ?>
    </ol></p>

</div>
</body>
</html>
